// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Smcells.pas' rev: 20.00

#ifndef SmcellsHPP
#define SmcellsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smcells
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMICellType { ictUnknown, ictEmpty, ictString, ictInteger, ictDecimal, ictDateTime, ictBoolean, ictMemo, ictDate, ictTime };
#pragma option pop

typedef void __fastcall (*TProgressPreviewCallback)(int Position, int TotalSize);

typedef void __fastcall (__closure *TOnColumnWidth)(System::TObject* Sender, int SheetNo, int ColumnNo, int Width);

typedef void __fastcall (__closure *TOnRowHeight)(System::TObject* Sender, int SheetNo, int RowNo, int Height);

typedef void __fastcall (__closure *TOnDimensions)(System::TObject* Sender, int SheetNo, int FirstRow, int LastRow, int FirstColumn, int LastColumn);

typedef void __fastcall (__closure *TOnCellValue)(System::TObject* Sender, int SheetNo, int Row, int Column, int FormatIndex, const System::Variant &Value, Classes::TAlignment Alignment, TSMICellType CellType);

typedef void __fastcall (__closure *TOnGetCellValue)(System::TObject* Sender, int SheetNo, int Row, int Column, System::Variant &Value);

typedef void __fastcall (__closure *TOnSheet)(System::TObject* Sender, System::WideString Caption, int Index, bool &Skip);

typedef void __fastcall (__closure *TSMIOnPasswordEvent)(System::TObject* Sender, System::UnicodeString &APassword, bool &Continue);

#pragma pack(push,1)
struct TBIFFRecordHeader
{
	
public:
	System::Word ID;
	System::Word Len;
};
#pragma pack(pop)


#pragma pack(push,1)
struct TBIFF12RecordHeader
{
	
public:
	unsigned ID;
	unsigned Len;
};
#pragma pack(pop)


typedef void __fastcall (__closure *TOnRecord)(System::TObject* Sender, TBIFFRecordHeader Header, System::Byte *Data);

class DELPHICLASS TSMICell;
class PASCALIMPLEMENTATION TSMICell : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	System::Variant FValue;
	Classes::TAlignment FAlignment;
	int FFormatIndex;
	TSMICellType FCellType;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::Variant Value = {read=FValue, write=FValue};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, default=0};
	__property int FormatIndex = {read=FFormatIndex, write=FFormatIndex, nodefault};
	__property TSMICellType CellType = {read=FCellType, write=FCellType, default=0};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMICell(void) { }
	
public:
	/* TObject.Create */ inline __fastcall TSMICell(void) : Classes::TPersistent() { }
	
};


class DELPHICLASS TSpreadSheetCols;
class PASCALIMPLEMENTATION TSpreadSheetCols : public Classes::TList
{
	typedef Classes::TList inherited;
	
public:
	TSMICell* __fastcall GetCell(int Col);
	void __fastcall SetCell(int Col, TSMICell* Value);
public:
	/* TList.Destroy */ inline __fastcall virtual ~TSpreadSheetCols(void) { }
	
public:
	/* TObject.Create */ inline __fastcall TSpreadSheetCols(void) : Classes::TList() { }
	
};


#pragma option push -b-
enum TSMIRowStatus { rsNormal, rsDeleted, rsError };
#pragma option pop

typedef Set<TSMIRowStatus, rsNormal, rsError>  TSMIRowStatuses;

class DELPHICLASS TSpreadSheetRow;
class PASCALIMPLEMENTATION TSpreadSheetRow : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FOriginalRecNo;
	TSMIRowStatus FStatus;
	bool FVisible;
	
public:
	int Index;
	TSpreadSheetCols* Cols;
	__fastcall virtual TSpreadSheetRow(void);
	__fastcall virtual ~TSpreadSheetRow(void);
	void __fastcall ClearValues(void);
	__property int OriginalRecNo = {read=FOriginalRecNo, write=FOriginalRecNo, nodefault};
	__property TSMIRowStatus Status = {read=FStatus, write=FStatus, default=0};
	__property bool Visible = {read=FVisible, write=FVisible, default=1};
};


class DELPHICLASS TSpreadSheetCells;
class PASCALIMPLEMENTATION TSpreadSheetCells : public Classes::TList
{
	typedef Classes::TList inherited;
	
private:
	int FColCount;
	int FRowCount;
	int FUsedColCount;
	int FUsedRowCount;
	
public:
	bool AutoUsedRangeDetect;
	__fastcall virtual TSpreadSheetCells(void);
	__fastcall virtual ~TSpreadSheetCells(void);
	int __fastcall AddRow(int i);
	void __fastcall RemoveRow(int i);
	virtual void __fastcall Clear(void);
	void __fastcall ClearSort(void);
	void __fastcall SortByColumn(int AColIndex, bool Ascending);
	System::Variant __fastcall GetValue(int Col, int Row);
	void __fastcall SetValue(int Col, int Row, const System::Variant &Value, Classes::TAlignment Alignment, int FormatIndex, TSMICellType CellType);
	System::Variant __fastcall ValueByCell(const System::UnicodeString ACellRange);
	System::Variant __fastcall ValueByRange(const System::UnicodeString ARange);
	__property int UsedColCount = {read=FUsedColCount, nodefault};
	__property int UsedRowCount = {read=FUsedRowCount, nodefault};
	__property int ColCount = {read=FColCount, write=FColCount, nodefault};
	__property int RowCount = {read=FRowCount, write=FRowCount, nodefault};
};


class DELPHICLASS TSpreadSheet;
class PASCALIMPLEMENTATION TSpreadSheet : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
public:
	TSpreadSheetCells* Cells;
	System::WideString Caption;
	Classes::TList* ColWidths;
	__fastcall virtual TSpreadSheet(Classes::TComponent* AOwner);
	__fastcall virtual ~TSpreadSheet(void);
	System::UnicodeString __fastcall PlainText();
};


class DELPHICLASS TSpreadSheets;
class PASCALIMPLEMENTATION TSpreadSheets : public Classes::TList
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TSpreadSheets(void);
	HIDESBASE int __fastcall Add(void);
	HIDESBASE void __fastcall Remove(int Index);
	virtual void __fastcall Clear(void);
	TSpreadSheet* __fastcall Spreadsheet(int Index);
	TSpreadSheet* __fastcall SheetByName(const System::WideString Value);
	int __fastcall SheetIndexByName(const System::WideString Value);
public:
	/* TObject.Create */ inline __fastcall TSpreadSheets(void) : Classes::TList() { }
	
};


class DELPHICLASS TSMRange;
class PASCALIMPLEMENTATION TSMRange : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FFirstRow;
	int FLastRow;
	int FFirstCol;
	int FLastCol;
	
public:
	__fastcall virtual TSMRange(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int FirstRow = {read=FFirstRow, write=FFirstRow, default=1};
	__property int LastRow = {read=FLastRow, write=FLastRow, default=2147483647};
	__property int FirstCol = {read=FFirstCol, write=FFirstCol, default=1};
	__property int LastCol = {read=FLastCol, write=FLastCol, default=2147483647};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMRange(void) { }
	
};


typedef void __fastcall (__closure *TErrorParseRecord)(System::TObject* Sender, Sysutils::Exception* Error, bool &Abort);

class DELPHICLASS TCustomSpreadSheetFile;
class PASCALIMPLEMENTATION TCustomSpreadSheetFile : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	System::UnicodeString FFileName;
	TErrorParseRecord FOnErrorProcess;
	bool FLoadNULLs;
	int FSheetIndex;
	TSMRange* FLoadRange;
	TOnColumnWidth FOnColumnWidth;
	TOnRowHeight FOnRowHeight;
	TOnDimensions FOnDimensions;
	TOnCellValue FOnCellValue;
	TOnGetCellValue FOnGetCellValue;
	TOnSheet FOnSheet;
	TOnRecord FOnRecord;
	void __fastcall SetLoadRange(TSMRange* Value);
	
public:
	bool IsIncrementalLoad;
	__fastcall virtual TCustomSpreadSheetFile(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomSpreadSheetFile(void);
	virtual bool __fastcall IsEncrypted(void);
	__property int SheetIndex = {read=FSheetIndex, write=FSheetIndex, default=-1};
	__property TSMRange* LoadRange = {read=FLoadRange, write=SetLoadRange};
	
__published:
	__property System::UnicodeString FileName = {read=FFileName, write=FFileName};
	__property bool LoadNULLs = {read=FLoadNULLs, write=FLoadNULLs, default=0};
	__property TOnColumnWidth OnColumnWidth = {read=FOnColumnWidth, write=FOnColumnWidth};
	__property TOnRowHeight OnRowHeight = {read=FOnRowHeight, write=FOnRowHeight};
	__property TOnDimensions OnDimensions = {read=FOnDimensions, write=FOnDimensions};
	__property TOnCellValue OnCellValue = {read=FOnCellValue, write=FOnCellValue};
	__property TOnGetCellValue OnGetCellValue = {read=FOnGetCellValue, write=FOnGetCellValue};
	__property TOnSheet OnSheet = {read=FOnSheet, write=FOnSheet};
	__property TOnRecord OnRecord = {read=FOnRecord, write=FOnRecord};
	__property TErrorParseRecord OnErrorProcess = {read=FOnErrorProcess, write=FOnErrorProcess};
};


typedef void __fastcall (__closure *TOnLoadProgress)(System::TObject* Sender, int Position, int TotalSize);

#pragma option push -b-
enum TSMIColumnNameKind { nkAlphabet, nkFieldName };
#pragma option pop

class DELPHICLASS TSpreadSheetFile;
class PASCALIMPLEMENTATION TSpreadSheetFile : public TCustomSpreadSheetFile
{
	typedef TCustomSpreadSheetFile inherited;
	
private:
	bool FParseBLOB;
	TOnLoadProgress FOnLoadProgress;
	TSMIColumnNameKind FNameKind;
	TSMIRowStatuses FLoadRowStatutes;
	void __fastcall DimsEvent(System::TObject* Sender, int SheetNo, int FirstRow, int LastRow, int FirstColumn, int LastColumn);
	void __fastcall SetCellEvent(System::TObject* Sender, int SheetNo, int Row, int Column, int FormatIndex, const System::Variant &Value, Classes::TAlignment Alignment, TSMICellType CellType);
	void __fastcall GetCellEvent(System::TObject* Sender, int SheetNo, int Row, int Column, System::Variant &Value);
	void __fastcall SheetEvent(System::TObject* Sender, System::WideString Caption, int Index, bool &Skip);
	void __fastcall ColumnWidthEvent(System::TObject* Sender, int SheetNo, int ColumnNo, int Width);
	
protected:
	TBIFFRecordHeader BufferHeader;
	bool CheckFileExists;
	void __fastcall UpdateProgress(int Position, int TotalSize);
	virtual void __fastcall ApplyEvents(void);
	virtual void __fastcall ReadBLOBValue(unsigned BlockNo, unsigned ASize, System::UnicodeString &s);
	void __fastcall SetRowStatus(int ASheetNo, int ARow, TSMIRowStatus AStatus);
	
public:
	TSpreadSheets* Sheets;
	TProgressPreviewCallback ReadProgressCallback;
	int LastLoadedRecNo;
	__fastcall virtual TSpreadSheetFile(Classes::TComponent* AOwner);
	__fastcall virtual ~TSpreadSheetFile(void);
	virtual void __fastcall LoadFromFile(const System::WideString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* AStream);
	virtual void __fastcall BeforeLoad(void);
	virtual void __fastcall AfterLoad(void);
	virtual bool __fastcall LoadRecord(int RecNo);
	
__published:
	__property TSMIColumnNameKind NameKind = {read=FNameKind, write=FNameKind, default=0};
	__property TSMIRowStatuses LoadRowStatutes = {read=FLoadRowStatutes, write=FLoadRowStatutes, default=1};
	__property TOnLoadProgress OnLoadProgress = {read=FOnLoadProgress, write=FOnLoadProgress};
	__property bool ParseBLOB = {read=FParseBLOB, write=FParseBLOB, default=1};
};


#pragma pack(push,1)
struct TBCD
{
	
public:
	System::Byte Precision;
	System::Byte SignSpecialPlaces;
	StaticArray<System::Byte, 32> Fraction;
};
#pragma pack(pop)


struct TSMIBCD
{
	
public:
	System::Byte Ctrl;
	StaticArray<System::Byte, 16> Data;
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE bool __fastcall IsNan(const double AValue);
extern PACKAGE int __fastcall GetSpreadSheetColID(System::UnicodeString s, int MaxColCount);
extern PACKAGE System::UnicodeString __fastcall GetSpreadSheetColByID(int ID);
extern PACKAGE bool __fastcall BCDToCurr(const TBCD &BCD, System::Currency &Curr);
extern PACKAGE bool __fastcall SMBCDToCurr(const TSMIBCD &smibcd, int Len, double &dbl);
extern PACKAGE System::TDateTime __fastcall Julian2DMY(int j);
extern PACKAGE double __fastcall DMY2Julian(const System::TDateTime AValue);

}	/* namespace Smcells */
using namespace Smcells;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SmcellsHPP
